local baseEntity = require("/Entities/baseEntity")
local Vector2 = require("/Scripts/vector2")
local baseMove = baseEntity:new()
baseMove.Position = Vector2:new(0, 0)
baseMove.Velocity = Vector2:new(0, 0)

function baseMove:move(x, y)
    self.Position.x = self.Position.x + x
    self.Position.y = self.Position.y + y
end

function baseMove:addvelocity(x, y)
    self.Velocity.x = self.Velocity.x + x
    self.Velocity.y = self.Velocity.y + y
end

function baseMove:setvelocity(x, y)
    self.Velocity.x = x
    self.Velocity.y = y
end

function baseMove:decayvelocity(intensity)
    if self.Velocity.x > 0 then
        self.Velocity.x = self.Velocity.x - intensity.x
    elseif self.Velocity.x < 0 then
        self.Velocity.x = self.Velocity.x + intensity.x
    end
    if self.Velocity.y > 0 then
        self.Velocity.y = self.Velocity.y - intensity.y
    elseif self.Velocity.y < 0 then
        self.Velocity.y = self.Velocity.y + intensity.y
    end
end

function baseMove:run()
    self:move(self.Velocity.x, self.Velocity.y)
    self:decayvelocity(Vector2:new(1, 1))
end

return baseMove