local render = {}
render.tiles = love.graphics.newImage("/Images/mapData/Overworld/tiles.png")
render.pixelmap = love.image.newImageData("/Images/mapData/Overworld/pixelmap.png")
render.default_tile = love.graphics.newQuad(160, 0, 32, 32, render.tiles:getDimensions())
render.tiles_avalible = {}
render.values_toconvert = {}
render.rgb_conversion = {}
render.rgb_conversion["0/0/0"] = 1
render.rgb_conversion["255/0/0"] = 2
render.rgb_conversion["0/255/0"] = 3
render.rgb_conversion["0/0/255"] = 4
render.rgb_conversion["255/255/0"] = 5

function render:load()
    self.values_toconvert = {}
    for y=0, self.pixelmap:getHeight()-1, 1 do
        for x=0, self.pixelmap:getWidth()-1, 1 do
            local r, g, b, a = self.pixelmap:getPixel(x, y)
            local height = a*100
            self.values_toconvert[tostring(x) .. "/" .. tostring(y)] = {r = math.ceil(r*255), g = math.ceil(g*255), b = math.ceil(b*255), height = height}
            
        end
    end
    self.tiles_avalible = {}
    for y = 0, self.tiles:getHeight()/32 do
        for x = 0, self.tiles:getWidth()/32 do
            local tile = love.graphics.newQuad(x*32, y*32, 32, 32, self.tiles:getDimensions())
            self.tiles_avalible[#self.tiles_avalible + 1] = tile
        end
    end
end

function render:render(s, e)
    if (e.y - s.y) > self.pixelmap:getHeight() and (e.x - s.x) > self.pixelmap:getWidth() then
        for y=0, self.pixelmap:getHeight()-1 do
            for x=0, self.pixelmap:getWidth()-1 do
                local current = self.values_toconvert[(x) .. "/" .. tostring(y)] or self.default_tile
                love.graphics.draw(self.tiles, self.tiles_avalible[self.rgb_conversion[tostring(current.r).."/"..tostring(current.g).."/"..tostring(current.b)]] or self.default_tile, x*32, y*32)
            end
        end
    else
        for y=0, e.y - s.y do
            for x=0, e.x - s.x do
                local current = self.values_toconvert[tostring(s.x+x) .. "/" .. tostring(s.y+y)] or self.default_tile
                love.graphics.draw(self.tiles, self.tiles_avalible[self.rgb_conversion[tostring(current.r).."/"..tostring(current.g).."/"..tostring(current.b)]] or self.default_tile, (s.x+x)*32, (s.y+y)*32)
            end
        end
    end
end

return render