local grid = {}
local Vector2 = require("/Scripts/vector2")

grid.size = Vector2:new(50, 50)

function grid:set(sx, sy)
    self.size = Vector2:new(sx, sy)
end

function grid:get(entity)
    local cells_needed = {}

    assert(self.size ~= Vector2:new(0, 0))

    local top_left = Vector2:new(entity.Position.x, entity.Position.y):vector_divide(self.size):floor()
    local bottom_right = Vector2:new(entity.Position.x + entity.width, entity.Position.y + entity.height):vector_divide(self.size):floor()

    for x=top_left.x, bottom_right.x do
        for y=top_left.y, bottom_right.y do
            table.insert(cells_needed, #cells_needed + 1, tostring(x) .. "/" .. tostring(y))
        end
    end

    return cells_needed
end

return grid