local Vector2 = require("../vector2")
local Grid = require("../grid")

local v = Vector2:new(16.25, 26.75)

assert(v.x == 16.25)
assert(v.y == 26.75)
assert(v:floor() == Vector2:new(16, 26))

assert(v:scalar_divide(2) == Vector2:new(8.125, 13.375))
assert(v:vector_divide(Vector2:new(2, 0.5)) == Vector2:new(16.25 / 2, 26.75 / 0.5))

Grid:set(50, 50, 0, 0)
local grids = Grid:get({ x = 75, y = 125, width = 120, height = 220 })

local expected = {
    "1/2", "1/3", "1/4", "1/5", "1/6",
    "2/2", "2/3", "2/4", "2/5", "2/6",
    "3/2", "3/3", "3/4", "3/5", "3/6" }

assert(#grids == #expected)
for i, v in ipairs(expected) do
    assert(grids[i] == v)
end
