local entitylist
local mworld
local system
local grid
local camera
local player
function love.load()
    local Vector2 = require("/Scripts/vector2")
    entitylist = require("/Scripts/entitylist")
    mworld = require("/Scripts/worldlist").mworld
    system = require("/Scripts/system")
    grid = require("/Scripts/grid")
    camera = system:add(mworld, entitylist.camera, true)
    player = system:add(mworld, entitylist.player, true)
    player.Position = Vector2:new(love.graphics.getWidth()/2-player.width/2, love.graphics.getHeight()/2-player.height/2)
    camera:attach(player)

    mworld.renderer:load()
end
function love.keypressed(key)
    system:addkey(key)
end

function love.keyreleased(key)
    system:keyreleased(key)
end

function love.update(dt)
    system:run(player.currentworld)
end

function love.draw()
    camera:set()
    system:draw(player.currentworld, camera)
    camera:unset()
end